/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	D3DBase.h													 */
/* eF		Direct3DNX `t@C								 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/03/07													 */
/* ========================================================================= */

#pragma once

class CXFile;

/* ========================================================================= */
/* 萔`																	 */
/* ========================================================================= */

#define CLNAME	"D3DBase"							/* NX */

/* ========================================================================= */
/* NX錾																 */
/* ========================================================================= */

typedef class CD3DBase
{
public:
			CD3DBase();										/* RXgN^ */
	virtual ~CD3DBase();									/* fXgN^ */

			HRESULT	Run		(HINSTANCE hInst, LPCSTR pszCaption, int nWidth, int nHeight, BOOL bWindow);	/* s */
			BOOL	Render	(void);									/* ` */
	virtual void	Cleanup	(void);									/* j */


protected:
			HRESULT	Init		(HWND hWnd, BOOL bWindow);	/*  */
	virtual	void	BeforeLoop	(void);						/* [vJnO */
			INT		Loop		(void);						/* C[v */
	virtual	void	AfterLoop	(void);						/* [vI */
			HRESULT	SetRender	(void);						/* _OXe[g̐ݒ */
	virtual	void	RenderScene	(void);						/* V[̕` */

	static LRESULT CALLBACK WndProcEntry(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);	/* CEBhEvV[W(Gg|Cg) */
	virtual LRESULT WndProc		(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);			/* CEBhEvV[W */
	virtual BOOL	OnCreate	(HWND hWnd, LPCREATESTRUCT lpCreateStruct);						/* bZ[Wnh(WM_CREATE) */
	virtual void	OnDestroy	(HWND hWnd);													/* bZ[Wnh(WM_DESTROY) */
	virtual void	OnSize		(HWND hWnd, UINT state, int cx, int cy);						/* bZ[Wnh(WM_SIZE) */


protected:
	BOOL					m_bWindow;						/* EBhE[h */
	HWND					m_hWnd;							/* EBhEnh */
	LPDIRECT3D9				m_pD3D;							/* C^[tFCX */
	LPDIRECT3DDEVICE9		m_pD3DDevice;					/* foCX */
	D3DPRESENT_PARAMETERS	m_stD3Dpp;						/* p[^\ */
	SIZE					m_sizeWindow;					/* EBhETCY */
} CD3DBase, *PCD3DBase;

/* Copyright(C)URARA-works 2006 */
