/* Copyright(C)URARA-works 2009 */
/* ========================================================================= */
/* t@CF	MainFrame.h													 */
/* eF		Ct[NX `t@C							 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2009/01/01													 */
/* ========================================================================= */

#pragma once

#include "D3DBase.h"

class CXFile;
class CPrimitiveRectangle;

/* ========================================================================= */
/* NX錾																 */
/* ========================================================================= */

typedef class CMainFrame : public CD3DBase
{
public:
			CMainFrame();							/* RXgN^ */
	virtual ~CMainFrame();							/* fXgN^ */


protected:
	void	BeforeLoop	(void);						/* [vJnO */
	void	AfterLoop	(void);						/* [vI */
	void	RenderScene	(void);						/* V[̕` */

	LRESULT WndProc			(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);			/* CEBhEvV[W */
	BOOL	OnCreate		(HWND hWnd, LPCREATESTRUCT lpCreateStruct);						/* bZ[Wnh(WM_CREATE) */
	void	OnDestroy		(HWND hWnd);													/* bZ[Wnh(WM_DESTROY) */
	void	OnLButtonDown	(HWND hWnd, BOOL fDoubleClick, int x, int y, UINT keyFlags);	/* bZ[Wnh(WM_LBUTTONDOWN) */
	void	OnRButtonDown	(HWND hWnd, BOOL fDoubleClick, int x, int y, UINT keyFlags);	/* bZ[Wnh(WM_RBUTTONDOWN) */
	void	OnRButtonUp		(HWND hWnd, int x, int y, UINT keyFlags);						/* bZ[Wnh(WM_RBUTTONUP) */
	void	OnMouseMove		(HWND hWnd, int x, int y, UINT keyFlags);						/* bZ[Wnh(WM_MOUSEMOVE) */
	void	OnMouseWheel	(HWND hWnd, int xPos, int yPos, int zDelta, UINT fwKeys);		/* bZ[Wnh(WM_MOUSEWHEEL) */


protected:
	POINT	m_ptPosBack;
	float	m_fDistance;
	BOOL m_bPush;
	D3DXVECTOR3 m_vecEye;		/* J̎_ */
	D3DXVECTOR3 m_vecAt;		/* J̒_ */
	D3DXVECTOR3 m_vec3Up;		/* Jg[h̏ */

	float m_fCameraAngle;			/* J̊px */

	CPrimitiveRectangle	*m_pRect;
} CMainFrame, *PCMainFrame;

/* Copyright(C)URARA-works 2009 */
